//----------------------------------------------------------------------//
//	񑀍															//
//																		//
//----------------------------------------------------------------------//
#ifndef UsrStrH
#define UsrStrH

#include <vcl.h>

//---------------------------------------------------------------------------
UnicodeString get_tkn(UnicodeString s, UnicodeString sp);
UnicodeString get_tkn_r(UnicodeString s, UnicodeString sp);
UnicodeString split_tkn(UnicodeString &s, UnicodeString sp);

UnicodeString split_dsc(UnicodeString &s);

int  extract_int(UnicodeString s);

bool remove_text(UnicodeString &s, UnicodeString w);
bool remove_top_text(UnicodeString &s, UnicodeString w);
bool remove_end_text(UnicodeString &s, UnicodeString w);

UnicodeString replace_str_by_list(UnicodeString s, TStringList *lst);

int pos_i(UnicodeString wd, UnicodeString s);
int pos_r(UnicodeString wd, UnicodeString s);
int pos_r_i(UnicodeString wd, UnicodeString s);
int pos_r_q(UnicodeString wd, UnicodeString s);

bool contains_word(UnicodeString lst, UnicodeString wd);

bool str_match(UnicodeString ptn, UnicodeString s);

bool find_mlt(UnicodeString wd, UnicodeString s, bool and_sw = false, bool not_sw = false, bool case_sw = false);
bool find_mlt_str(UnicodeString wd, UnicodeString s, TStringList *lst, bool case_sw);

TStringDynArray get_csv_array(UnicodeString src, int size, bool force_size = false);
UnicodeString make_csv_str(UnicodeString s);
UnicodeString make_csv_rec_str(TStringDynArray lst);
int indexof_csv_list(TStringList *lst, UnicodeString s, int p);
TStringDynArray record_of_csv_list(TStringList *lst, UnicodeString s, int p, int size);

UnicodeString conv_esc_char(UnicodeString s);
UnicodeString add_quot_if_spc(UnicodeString s);
UnicodeString exclude_quot(UnicodeString s);

UnicodeString __fastcall mSecToTStr(unsigned int ms);
UnicodeString __fastcall SecToTStr(unsigned int scnt);

UnicodeString fit_StrToPanel(UnicodeString s, int p, TPanel *pp);

int str_len_half(UnicodeString s);
int str_len_unicode(UnicodeString s);

UnicodeString align_r_str(UnicodeString s, int wd, UnicodeString post_s = EmptyStr);
UnicodeString align_l_str(UnicodeString s, int wd, UnicodeString post_s = EmptyStr);
UnicodeString minimize_str(UnicodeString s, TCanvas *cv, int wd, bool omit_end = false);

UnicodeString to_HalfWidth(UnicodeString s, bool is_fnam = false);
UnicodeString to_FullWidth(UnicodeString s);

int is_RuledLine(UnicodeString s);

UnicodeString get_ShiftStr(TShiftState Shift);
UnicodeString get_KeyStr(WORD Key);
UnicodeString get_KeyStr(WORD Key, TShiftState Shift);

UnicodeString get_AddrStr(__int64 adr, int w = 0);

UnicodeString abs_to_reldir(UnicodeString fnam, UnicodeString rnam);

//---------------------------------------------------------------------------
#endif
