//----------------------------------------------------------------------//
// HtmlImgQ																//
//----------------------------------------------------------------------//
#ifndef Unit1H
#define Unit1H

//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <System.Actions.hpp>
#include <System.IniFiles.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.ExtCtrls.hpp>
#include <Vcl.ComCtrls.hpp>
#include <Vcl.ActnCtrls.hpp>
#include <Vcl.ActnList.hpp>
#include <Vcl.Dialogs.hpp>
#include <Vcl.ExtDlgs.hpp>
#include <Vcl.FileCtrl.hpp>
#include <Vcl.Buttons.hpp>

//---------------------------------------------------------------------------
class THtmlImgForm : public TForm
{
__published:	// IDE ŊǗR|[lg
	TAction *DelBtnAction;
	TAction *DowBtnAction;
	TAction *OkAction;
	TAction *UpBtnAction;
	TActionList *ActionList1;
	TButton *CancelBtn;
	TButton *DelMenuBtn;
	TButton *DowMenuBtn;
	TButton *OkBtn;
	TButton *SelectBtn;
	TButton *UpMenuBtn;
	TComboBox *AlignComboBox;
	TLabel *Label1;
	TLabeledEdit *BorderEdit;
	TLabeledEdit *HspaceEdit;
	TLabeledEdit *VspaceEdit;
	TListBox *ImgListBox;
	TOpenPictureDialog *OpenPictureDialog1;
	TRadioGroup *BrRadioGroup;

	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall CancelBtnClick(TObject *Sender);
	void __fastcall SelectBtnClick(TObject *Sender);
	void __fastcall DelBtnActionExecute(TObject *Sender);
	void __fastcall DelBtnActionUpdate(TObject *Sender);
	void __fastcall UpBtnActionExecute(TObject *Sender);
	void __fastcall UpBtnActionUpdate(TObject *Sender);
	void __fastcall DowBtnActionExecute(TObject *Sender);
	void __fastcall DowBtnActionUpdate(TObject *Sender);
	void __fastcall OkActionExecute(TObject *Sender);
	void __fastcall OkActionUpdate(TObject *Sender);

private:	// [U[錾
	TIniFile *IniFile;
	UnicodeString ImgPath;
	UnicodeString DocPath;

public:		// [U[錾
	__fastcall THtmlImgForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE THtmlImgForm *HtmlImgForm;
//---------------------------------------------------------------------------
#endif
