//----------------------------------------------------------------------//
// 񑀍															//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <System.StrUtils.hpp>
#include <System.Masks.hpp>
#include "usr_str.h"

//---------------------------------------------------------------------------
// wZp[^̑O̕擾
// Zp[^Ȃꍇ́Â܂ܕԂ
//---------------------------------------------------------------------------
UnicodeString get_tkn(UnicodeString s, UnicodeString sp)
{
	int p = s.Pos(sp);
	if (p==0)
		return s;
	else
		return s.SubString(1,p-1);
}
//---------------------------------------------------------------------------
// wZp[^̌̕擾
// Zp[^Ȃꍇ́AEmptyStr Ԃ
//---------------------------------------------------------------------------
UnicodeString get_tkn_r(UnicodeString s, UnicodeString sp)
{
	int p = s.Pos(sp);
	if (p==0)
		return EmptyStr;
	else
		return s.SubString(p+sp.Length(), s.Length()-(p-sp.Length()+1));
}
//---------------------------------------------------------------------------
// wZp[^O̕𕪗Ď擾
// Zp[^Ȃꍇ́Â܂ܕԂA͋
//---------------------------------------------------------------------------
UnicodeString split_tkn(UnicodeString &s, UnicodeString sp)
{
	UnicodeString r;
	int p = s.Pos(sp);
	if (p==0) {
		r = s;
		s = EmptyStr;
	}
	else {
		r = s.SubString(1,p-1);
		s = s.SubString(p+sp.Length(), s.Length()-(p-sp.Length()+1));
	}
	return r;
}

//---------------------------------------------------------------------------
//񂩂(^:`:)𕪗擾
//---------------------------------------------------------------------------
UnicodeString split_dsc(UnicodeString &s)
{
	UnicodeString dsc;
	if (StartsStr(":", s)) {
		s.Delete(1,1);
		dsc = split_tkn(s, ":");
		s = s.Trim();
	}
	return dsc;
}

//---------------------------------------------------------------------------
// 񂩂w폜
// ߂l ture: 폜/ false: ꂪ܂܂ĂȂ
//---------------------------------------------------------------------------
bool remove_text(UnicodeString &s, UnicodeString w)
{
	if (ContainsText(s, w)) {
		s = ReplaceText(s, w, EmptyStr);
		return true;
	}
	else
		return false;
}
//---------------------------------------------------------------------------
// ̐擪Ɏwꂪ폜
// ߂l ture: 폜/ false: 擪ɌꂪȂ
//---------------------------------------------------------------------------
bool remove_top_text(UnicodeString &s, UnicodeString w)
{
	if (!StartsText(w, s)) return false;
	s.Delete(1, w.Length());
	return true;
}
//---------------------------------------------------------------------------
// ̖Ɏwꂪ폜
// ߂l ture: 폜/ false: 擪ɌꂪȂ
//---------------------------------------------------------------------------
bool remove_end_text(UnicodeString &s, UnicodeString w)
{
	if (!EndsText(w, s)) return false;
	s.Delete(s.Length() - w.Length() + 1, w.Length());
	return true;
}

//---------------------------------------------------------------------------
// Xgɂĕu
// Xg:  TAB u
//---------------------------------------------------------------------------
UnicodeString replace_str_by_list(UnicodeString s, TStringList *lst)
{
	for (int i=0; i<lst->Count; i++) {
		UnicodeString t_s = lst->Strings[i];
		UnicodeString f_s = split_tkn(t_s, "\t");
		s = ReplaceStr(s, f_s, t_s);
	}
	return s;
}

//---------------------------------------------------------------------------
//񂩂琮l𒊏o
//sO𑗏o
//---------------------------------------------------------------------------
int extract_int(UnicodeString s)
{
	int i = 1;
	while (i<=s.Length()) if (!iswdigit(s[i])) s.Delete(i, 1); else i++;
	return s.ToInt();
}

//---------------------------------------------------------------------------
//召ʂɕ
//  wd: 
//   s: Ώە
//---------------------------------------------------------------------------
int pos_i(UnicodeString wd, UnicodeString s)
{
	if (wd.IsEmpty()) return 0;
	return s.UpperCase().Pos(wd.UpperCase());
}
//---------------------------------------------------------------------------
// 񂪍ŌɌʒu擾
//  wd: 
//   s: Ώە
//---------------------------------------------------------------------------
int pos_r(UnicodeString wd, UnicodeString s)
{
	if (wd.IsEmpty()) return 0;
	UnicodeString ss = s;
	int p = 0;
	for (;;) {
		int p1 = ss.Pos(wd);
		if (p1==0) break;
		ss.Delete(1,p1);
		p += p1;
	}
	return p;
}
//---------------------------------------------------------------------------
// 召ʂɕ񂪍ŌɌʒu擾
//  wd: 
//   s: Ώە
//---------------------------------------------------------------------------
int pos_r_i(UnicodeString wd, UnicodeString s)
{
	if (wd.IsEmpty()) return 0;
	UnicodeString ss = s;
	int p = 0;
	for (;;) {
		int p1 = pos_i(wd, ss);
		if (p1==0) break;
		ss.Delete(1,p1);
		p += p1;
	}
	return p;
}

//---------------------------------------------------------------------------
// pOŁA񂪍ŌɌʒu擾
//  wd: ( \v ͏)
//   s: Ώە
//---------------------------------------------------------------------------
int pos_r_q(UnicodeString wd, UnicodeString s)
{
	if (wd.IsEmpty()) return 0;
	UnicodeString ss;
	bool q_flag = false;
	for (int i=1; i<=s.Length(); i++) {
		WideChar c = s[i];
		//pO
		if (!q_flag) {
			if (c=='\"') q_flag = true;
		}
		//p
		else {
			if (c=='\"')
				q_flag = false;
			else
				c = '\v';
		}
		ss += c;
	}
	return pos_r(wd, ss);
}

//---------------------------------------------------------------------------
// | ؂胊XgɎwꂪ܂܂Ă邩H
//---------------------------------------------------------------------------
bool contains_word(UnicodeString lst, UnicodeString wd)
{
	if (!StartsStr("|", lst)) lst = "|" + lst;
	if (!EndsStr("|", lst))   lst += "|";
	return ContainsText(lst, "|"+wd+"|");
}

//---------------------------------------------------------------------------
//ChJ[h܂ރp^[ɂ镶v
//---------------------------------------------------------------------------
bool str_match(UnicodeString ptn, UnicodeString s)
{
	try {
		return MatchesMask(s, ptn);
	}
	catch (...) {
		return false;
	}
}

//---------------------------------------------------------------------------
//̕ OR/AND 
//       wd:  (̏ꍇ͔p܂͑Sp󔒂ŋ؂j
//        s: Ώە
//   and_sw: AND		(default = false)
//   not_sw: NOT		(default = false)
//  case_sw: 召	(default = false)
//---------------------------------------------------------------------------
bool find_mlt(UnicodeString  wd, UnicodeString s,
	bool and_sw, bool not_sw, bool case_sw)
{
	if (wd.IsEmpty()) return false;

	//ꃊXg쐬
	std::unique_ptr<TStringList> wlst(new TStringList());
	for (;;) {
		if (wd.IsEmpty()) break;
		int p = wd.Pos(" ");
		if (p==1)
			wd.Delete(1,1);
		else if (p>1) {
			wlst->Add(wd.SubString(1,p-1));  wd.Delete(1,p);
		}
		else {
			p = wd.Pos("@");
			if (p==1)
				wd.Delete(1,1);
			else if (p>1) {
				wlst->Add(wd.SubString(1,p-1));  wd.Delete(1,p+1);
			}
			else {
				wlst->Add(wd); break;
			}
		}
	}

	//󔒂^uϊ
	for (int i=0; i<wlst->Count; i++) wlst->Strings[i] = conv_esc_char(wlst->Strings[i]);

	//
	bool ret = and_sw;
	for (int i=0; i<wlst->Count; i++) {
		int p = case_sw? s.Pos(wlst->Strings[i]) : pos_i(wlst->Strings[i], s);
		if (!not_sw) {
			//܂
			if (p>0) {
				//ꂩ
				if (!and_sw) { ret = true; break; }
			}
			else {
				//SĂ
				if (and_sw) { ret = false; break; }
			}
		}
		else {
			//܂܂Ȃ
			if (p==0) {
				//ꂩ
				if (!and_sw) { ret = true; break; }
			}
			else {
				//SĂ
				if (and_sw) { ret = false; break; }
			}
		}
	}

	return ret;
}

//---------------------------------------------------------------------------
//̕A}b`̃Xg擾
//       wd:  (̏ꍇ͔p܂͑Sp󔒂ŋ؂j
//        s: Ώە
// (O)  lst: ۂɃ}b`ݒ肷郊Xg
//  case_sw: 召	(default = false)
//---------------------------------------------------------------------------
bool find_mlt_str(UnicodeString wd, UnicodeString s, TStringList *lst, bool case_sw)
{
	lst->Clear();
	if (wd.IsEmpty()) return false;

	//ꃊXg쐬
	std::unique_ptr<TStringList> wlst(new TStringList());
	for (;;) {
		if (wd.IsEmpty()) break;
		int p = wd.Pos(" ");
		if (p==1)
			wd.Delete(1,1);
		else if (p>1) {
			wlst->Add(wd.SubString(1,p-1));  wd.Delete(1,p);
		}
		else {
			p = wd.Pos("@");
			if (p==1)
				wd.Delete(1,1);
			else if (p>1) {
				wlst->Add(wd.SubString(1,p-1));  wd.Delete(1,p+1);
			}
			else {
				wlst->Add(wd); break;
			}
		}
	}

	//󔒂^uϊ
	for (int i=0; i<wlst->Count; i++) wlst->Strings[i] = conv_esc_char(wlst->Strings[i]);

	//
	for (int i=0; i<wlst->Count; i++) {
		UnicodeString wd = wlst->Strings[i];
		int p = case_sw? s.Pos(wd) : pos_i(wd, s);
		if (p>0) {
			UnicodeString fwd = s.SubString(p, wd.Length());
			if (lst->IndexOf(fwd)==-1) lst->Add(fwd);
		}
	}

	return (lst->Count>0);
}

//---------------------------------------------------------------------------
//CSVړe擾
// force_size : TCYIɐݒ  (default = false)
//---------------------------------------------------------------------------
TStringDynArray get_csv_array(UnicodeString src, int size, bool force_size)
{
	TStringDynArray ret_array;
	ret_array.set_length(size);

	UnicodeString str_buf = src;
	UnicodeString itm_buf;
	int cnt = 0, qp;
	bool quit = false;
	while (!quit) {
		str_buf = str_buf.Trim();
		//擪 "
		if (StartsStr("\"", str_buf)) {
			str_buf.Delete(1, 1); itm_buf = EmptyStr;
			while (1) {
				qp = str_buf.Pos("\"");
				//" 
				if (qp) {
					if (qp<str_buf.Length()) {
						//"`"  "
						if (str_buf.IsDelimiter("\"", qp+1)) {
							itm_buf += str_buf.SubString(1, qp);
							str_buf.Delete(1, qp+1);
						}
						//Ή "
						else {
							itm_buf += str_buf.SubString(1, qp-1);
							str_buf.Delete(1, qp).Trim();
							if (StartsStr(",", str_buf))
								str_buf.Delete(1,1);
							else
								str_buf = EmptyStr;	//sȕ
							break;
						}
					}
					// " (Ō̍)
					else {
						itm_buf += str_buf.Delete(qp, 1);
						str_buf = EmptyStr;
						quit   = true;
						break;
					}
				}
				//Ή " Ȃ
				else {
					itm_buf = get_tkn(str_buf, ",");	//*
					str_buf = EmptyStr;
					break;
				}
			}
		}
		//擪 " ł͂Ȃ
		else {
			qp = str_buf.Pos(",");
			if (qp) {
				itm_buf = str_buf.SubString(1, qp-1);
				str_buf.Delete(1,qp);
			}
			//Ō̍
			else {
				itm_buf = str_buf;
				str_buf = EmptyStr;
				quit	= true;
			}
		}

		ret_array[cnt++] = itm_buf;
		if (cnt==size) quit = true;
	}

	if (!force_size) ret_array.set_length(cnt);
	return ret_array;
}

//---------------------------------------------------------------------------
//CSVڂ쐬
//---------------------------------------------------------------------------
UnicodeString make_csv_str(UnicodeString s)
{
	s = ReplaceStr(s, "\"", "\"\"");
	s = "\"" + s + "\"";
	return s;
}
//---------------------------------------------------------------------------
UnicodeString make_csv_rec_str(TStringDynArray lst)
{
	UnicodeString lbuf;
	for (int i=0; i<lst.Length; i++) {
		if (i>0) lbuf += ",";
		lbuf += make_csv_str(lst[i]);
	}
	return lbuf;
}

//---------------------------------------------------------------------------
//CSṼXg p Ԗڂ̍ڂ s ̃CfbNX擾
//---------------------------------------------------------------------------
int indexof_csv_list(TStringList *lst, UnicodeString s, int p)
{
	int idx = -1;
	for (int i=0; i<lst->Count && idx==-1; i++) {
		TStringDynArray itm_buf = get_csv_array(lst->Strings[i], p+1, true);
		if (SameText(s, itm_buf[p])) idx = i;
	}
	return idx;
}
//---------------------------------------------------------------------------
//CSṼXg p Ԗڂ̍ڂ s ̃R[h擾
//---------------------------------------------------------------------------
TStringDynArray record_of_csv_list(TStringList *lst, UnicodeString s, int p, int size)
{
	TStringDynArray ret_array;
	int idx = indexof_csv_list(lst, s, p);
	if (idx!=-1) ret_array = get_csv_array(lst->Strings[idx], size, true);
	return ret_array;
}

//--------------------p-------------------------------------------------------
//GXP[vV[PX̕ϊ
//---------------------------------------------------------------------------
UnicodeString conv_esc_char(UnicodeString s)
{
	if (s.IsEmpty()) return EmptyStr;

	s = ReplaceStr(s, "\\\\", "\f");	//\\ ꎞI \f ɕςĂ
	s = ReplaceStr(s, "\\t", "\t");		//^u
	s = ReplaceStr(s, "\\n", "\r\n");	//s
	s = ReplaceStr(s, "\\s", " ");		//NyanFi ŗL
	s = ReplaceStr(s, "\f", "\\");		//\\(\f)  \ ɕϊ
	return s;
}

//---------------------------------------------------------------------------
//󔒂܂łꍇApň͂
//---------------------------------------------------------------------------
UnicodeString add_quot_if_spc(UnicodeString s)
{
	if (ContainsText(s, " ") || ContainsText(s, "@")) s = "\""+ s + "\"";
	return s;
}

//---------------------------------------------------------------------------
//pO
//---------------------------------------------------------------------------
UnicodeString exclude_quot(UnicodeString s)
{
	int len = s.Length();
	if (len>=2 && (StartsStr("\"", s) && EndsStr("\"", s) || StartsStr("'", s) && EndsStr("'", s)))
		s = s.SubString(2, len-2);
	return s;
}

//---------------------------------------------------------------------------
//mb玞ԕ
//---------------------------------------------------------------------------
UnicodeString __fastcall mSecToTStr(unsigned int ms)
{
	int scnt = ms/1000;	//b
	int c = (ms/10)%100;
	int s = scnt % 60;	scnt /= 60;
	int m = scnt % 60;
	int h = scnt / 60;
	return UnicodeString().sprintf(_T("%02u:%02u:%02u.%02u"), h, m, s, c);
}
//---------------------------------------------------------------------------
//b玞ԕ
//---------------------------------------------------------------------------
UnicodeString __fastcall SecToTStr(unsigned int scnt)
{
	int s = scnt % 60;	scnt /= 60;
	int m = scnt % 60;
	int h = scnt / 60;
	return UnicodeString().sprintf(_T("%02u:%02u:%02u"), h, m, s);
}

//---------------------------------------------------------------------------
//  TPanel ̕ςɎ܂悤ɁAwʒu󔒂}
//---------------------------------------------------------------------------
UnicodeString fit_StrToPanel(UnicodeString s, int p, TPanel *pp)
{
	HDC dc = ::GetDC(pp->Handle);
	if (dc) {
		try {
			std::unique_ptr<TCanvas> cv(new TCanvas());
			cv->Handle = dc;
			cv->Font->Assign(pp->Font);
			while (cv->TextWidth(s+"  ")<pp->ClientWidth) s.Insert(" ", p);
		}
		__finally {
			::ReleaseDC(pp->Handle, dc);
		}
	}
	return s;
}

//---------------------------------------------------------------------------
//pZ̕񒷂擾
//---------------------------------------------------------------------------
int str_len_half(UnicodeString s)
{
	AnsiString    s_a = s;
	UnicodeString s_u = s_a;
	if (s!=s_u && s.Length()==s_u.Length()) {
		for (int i=1; i<=s.Length(); i++)
			if (s[i]!=s_u[i] && s_u[i]=='?') s_u[i] = _T('H');
		s_a = s_u;
	}
	return s_a.Length();
}

//---------------------------------------------------------------------------
//TQ[gyAlĕ擾
//---------------------------------------------------------------------------
int str_len_unicode(UnicodeString s)
{
	int n = 0;
	for (int i=1; i<=s.Length(); i++) if (!s.IsTrailSurrogate(i)) n++;
	return n;
}

//---------------------------------------------------------------------------
// w蕝(pP)ŕ񂪉ElɂȂ悤ɋ󔒂}
//---------------------------------------------------------------------------
UnicodeString align_r_str(UnicodeString s, int wd, UnicodeString post_s)
{
	int n = str_len_half(s);
	if (n<wd) s = StringOfChar(' ', wd-n) + s;
	return s + post_s;
}
//---------------------------------------------------------------------------
// w蕝(pP)ŕ񂪍lɂȂ悤ɋ󔒂}
//---------------------------------------------------------------------------
UnicodeString align_l_str(UnicodeString s, int wd, UnicodeString post_s)
{
	int n = str_len_half(s);
	if (n<wd) s += StringOfChar(' ', wd-n);
	return s + post_s;
}

//---------------------------------------------------------------------------
// 񂪎w蕝Ɏ܂悤ɒ
// omit_end : ȗ (default = false : Ԃȗ)
//---------------------------------------------------------------------------
UnicodeString minimize_str(UnicodeString s, TCanvas *cv, int wd, bool omit_end)
{
	if (cv->TextWidth(s) >= wd) {
		if (omit_end) {
			s += "c";
			int p = s.Length()-1;
			while (p>0) {
				s.Delete(p--, 1);
				if (cv->TextWidth(s)<=wd) break;
			}
		}
		else {
			int p = 0;
			for (int i=1; i<s.Length(); i++) {
				if (cv->TextWidth(s.SubString(1, i)) > wd/2) {
					p = i-1; break;
				}
			}
			if (p==0) p = 1;
			s.Insert("c", p);	p += 1;
			while (s.Length()>=p) {
				s.Delete(p, 1);
				if (cv->TextWidth(s)<=wd) break;
			}
		}
	}
	return s;
}

//---------------------------------------------------------------------------
//pɕϊ
// is_fnam : t@C (default = false)
//---------------------------------------------------------------------------
UnicodeString to_HalfWidth(UnicodeString s, bool is_fnam)
{
	UnicodeString ret_str;
	//t@C
	if (is_fnam) {
		UnicodeString full_ch = "Ifij{C|OPQRSTUVWXG`abcdefghijklmnopqrstuvwxymnop`@";
		UnicodeString half_ch = "!#$%&'()+,-0123456789;=@ABCDEFGHIJKLMNOPQRSTUVWXYZ[]abcdefghijklmnopqrstuvwxyz{}~ ";
		for (int i=1; i<=s.Length(); i++) {
			int p = full_ch.Pos(s[i]);
			if (p>0) s[i] = half_ch[p];
		}
		ret_str = s;
	}
	//
	else {
		const int size = s.Length() + 1;
		std::unique_ptr<wchar_t> sbuf(new wchar_t[size]);
		::ZeroMemory(sbuf.get(), size * sizeof(wchar_t));
		::LCMapString(::GetUserDefaultLCID(), LCMAP_HALFWIDTH, s.c_str(), size, sbuf.get(), size);
		ret_str = sbuf.get();
	}
	return ret_str;
}
//---------------------------------------------------------------------------
//Spɕϊ
//---------------------------------------------------------------------------
UnicodeString to_FullWidth(UnicodeString s)
{
	const int size = s.Length() + 1;
	std::unique_ptr<wchar_t> sbuf(new wchar_t[size]);
	::ZeroMemory(sbuf.get(), size * sizeof(wchar_t));
	::LCMapString(::GetUserDefaultLCID(), LCMAP_FULLWIDTH, s.c_str(), size, sbuf.get(), size);
	UnicodeString ret_str = sbuf.get();
	return ret_str;
}

//---------------------------------------------------------------------------
//rsH
//---------------------------------------------------------------------------
int is_RuledLine(UnicodeString s)
{
	return SameStr(s, StringOfChar(_T(''), s.Length()))? 1 :
			(SameStr(s, StringOfChar(_T(''), s.Length()))? 2 : 0);
}

//---------------------------------------------------------------------------
//VtgԂ𕶎
//---------------------------------------------------------------------------
UnicodeString get_ShiftStr(TShiftState Shift)
{
	UnicodeString sftstr;
	if (Shift.Contains(ssShift)) sftstr += "Shift+";
	if (Shift.Contains(ssCtrl))  sftstr += "Ctrl+";
	if (Shift.Contains(ssAlt))   sftstr += "Alt+";
	return  sftstr;
}
//---------------------------------------------------------------------------
//L[𕶎
//---------------------------------------------------------------------------
UnicodeString get_KeyStr(WORD Key)
{
	UnicodeString keystr;

	switch (Key) {
	case VK_RETURN: keystr = "ENTER";	break;
	case VK_ESCAPE: keystr = "ESC";		break;
	case VK_SPACE:  keystr = "SPACE";	break;
	case VK_TAB:	keystr = "TAB";		break;
	case VK_LEFT:   keystr = "LEFT";	break;
	case VK_RIGHT:  keystr = "RIGHT";	break;
	case VK_DOWN:	keystr = "DOWN";	break;
	case VK_UP:		keystr = "UP";		break;
	case VK_PRIOR:	keystr = "PGUP";	break;
	case VK_NEXT:	keystr = "PGDN";	break;
	case VK_HOME:	keystr = "HOME";	break;
	case VK_END:	keystr = "END";		break;
	case VK_DELETE: keystr = "DEL";		break;
	case VK_BACK: 	keystr = "BKSP";	break;
	case VK_F1:		keystr = "F1";		break;
	case VK_F2:		keystr = "F2";		break;
	case VK_F3:		keystr = "F3";		break;
	case VK_F4:		keystr = "F4";		break;
	case VK_F5:		keystr = "F5";		break;
	case VK_F6:		keystr = "F6";		break;
	case VK_F7:		keystr = "F7";		break;
	case VK_F8:		keystr = "F8";		break;
	case VK_F9:		keystr = "F9";		break;
	case VK_F10:	keystr = "F10";		break;
	case VK_F11:	keystr = "F11";		break;
	case VK_F12:	keystr = "F12";		break;
	case VK_OEM_1:  keystr = ":";		break;
	case VK_OEM_2:  keystr = "/";		break;
	case VK_OEM_3:  keystr = "@";		break;
	case VK_OEM_4:  keystr = "[";		break;
	case VK_OEM_5:  keystr = "\\";		break;
	case VK_OEM_6:  keystr = "]";		break;
	case VK_OEM_MINUS:  keystr = "-";	break;
	case VK_OEM_PLUS:   keystr = ";";	break;
	case VK_OEM_COMMA:  keystr = ",";	break;
	case VK_OEM_PERIOD: keystr = ".";	break;
	case VK_OEM_102:    keystr = "_";	break;

	case VK_NUMPAD0:  keystr = "10Key_0"; break;
	case VK_NUMPAD1:  keystr = "10Key_1"; break;
	case VK_NUMPAD2:  keystr = "10Key_2"; break;
	case VK_NUMPAD3:  keystr = "10Key_3"; break;
	case VK_NUMPAD4:  keystr = "10Key_4"; break;
	case VK_NUMPAD5:  keystr = "10Key_5"; break;
	case VK_NUMPAD6:  keystr = "10Key_6"; break;
	case VK_NUMPAD7:  keystr = "10Key_7"; break;
	case VK_NUMPAD8:  keystr = "10Key_8"; break;
	case VK_NUMPAD9:  keystr = "10Key_9"; break;
	case VK_MULTIPLY: keystr = "10Key_*"; break;
	case VK_ADD:	  keystr = "10Key_+"; break;
	case VK_SUBTRACT: keystr = "10Key_-"; break;
	case VK_DIVIDE:   keystr = "10Key_/"; break;
	case VK_DECIMAL:  keystr = "10Key_."; break;

	case VK_OEM_7:
		keystr = (::GetKeyboardType(0)==7)? "^" : "'";
		break;

	default:
		if (_istalnum(Key)) keystr = (char)Key; else keystr = EmptyStr;
	}
	return  keystr;
}
//---------------------------------------------------------------------------
//L[ƃVtgԂ𕶎
//---------------------------------------------------------------------------
UnicodeString get_KeyStr(WORD Key, TShiftState Shift)
{
	return  get_ShiftStr(Shift) + get_KeyStr(Key);
}

//---------------------------------------------------------------------------
//AhX擾
// w: \ (default = 0)
//---------------------------------------------------------------------------
UnicodeString get_AddrStr(__int64 adr, int w)
{
	UnicodeString ret_str;
	if (adr>=0) {
		unsigned int adr_l = adr & 0xffffffffLL;
		int adr_h = adr>>32;
		ret_str = UnicodeString().sprintf(_T("%08X"), adr_l);
		ret_str.Insert(":", 5);
		if (adr_h>0) ret_str = IntToHex(adr_h, 1) + ":" + ret_str;
		ret_str = align_r_str(ret_str, w);
	}
	else
		ret_str = "____:____";
	return ret_str;
}

//---------------------------------------------------------------------------
//΃pX瑊΃pX
// fnam: ϊΏۃt@C
// rnam: fBNg
//---------------------------------------------------------------------------
UnicodeString abs_to_reldir(UnicodeString fnam, UnicodeString rnam)
{
	if (ExtractFileDrive(fnam).IsEmpty()) return fnam;
	if (rnam.IsEmpty()) return fnam;
	if (ExtractFileDrive(fnam) != ExtractFileDrive(rnam)) return fnam;

	rnam = IncludeTrailingPathDelimiter(rnam);

	for (;;) {
		int pf = fnam.Pos("\\");
		int pd = rnam.Pos("\\");
		if (pf>0 && pd>0) {
			if (SameText(fnam.SubString(1,pf), rnam.SubString(1,pd))) {
				fnam.Delete(1,pf);
				rnam.Delete(1,pd);
			}
			else {
				rnam.Delete(1,pd);
				fnam = "..\\"+fnam;
				for (;;) {
					pd = rnam.Pos("\\");  if (pd==0) break;
					rnam.Delete(1,pd);
					fnam = "..\\"+fnam;
				}
				break;
			}
		}
		else if (pf==0 && pd>0) {
			rnam.Delete(1,pd);
			fnam = "..\\"+fnam;
			for (;;) {
				pd = rnam.Pos("\\");  if (pd==0) break;
				rnam.Delete(1,pd);
				fnam = "..\\"+fnam;
			}
			break;
		}
		else break;
	}
	return fnam;
}
//---------------------------------------------------------------------------

